"use strict";exports.__esModule=true;exports.collectPages=collectPages;exports.printTreeView=printTreeView;exports.getFileForPage=getFileForPage;exports.getSpecifiedPages=getSpecifiedPages;exports.getCacheIdentifier=getCacheIdentifier;exports.getPageSizeInKb=getPageSizeInKb;var _chalk=_interopRequireDefault(require("chalk"));var _crypto=_interopRequireDefault(require("crypto"));var _findUp=_interopRequireDefault(require("find-up"));var _fs=_interopRequireDefault(require("fs"));var _textTable=_interopRequireDefault(require("next/dist/compiled/text-table"));var _path=_interopRequireDefault(require("path"));var _stripAnsi=_interopRequireDefault(require("strip-ansi"));var _util=require("util");var _prettyBytes=_interopRequireDefault(require("../lib/pretty-bytes"));var _recursiveReaddir=require("../lib/recursive-readdir");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}const fsStat=(0,_util.promisify)(_fs.default.stat);const fsExists=(0,_util.promisify)(_fs.default.exists);const fsReadFile=(0,_util.promisify)(_fs.default.readFile);function collectPages(directory,pageExtensions){return(0,_recursiveReaddir.recursiveReadDir)(directory,new RegExp(`\\.(?:${pageExtensions.join('|')})$`));}function printTreeView(list,pageInfos){const getPrettySize=_size=>{const size=(0,_prettyBytes.default)(_size);// green for 0-100kb
if(_size<100*1000)return _chalk.default.green(size);// yellow for 100-250kb
if(_size<250*1000)return _chalk.default.yellow(size);// red for >= 250kb
return _chalk.default.red.bold(size);};const messages=[['Page','Size','Files','Packages'].map(entry=>_chalk.default.underline(entry))];list.sort((a,b)=>a.localeCompare(b)).forEach((item,i)=>{const symbol=i===0?list.length===1?'─':'┌':i===list.length-1?'└':'├';const pageInfo=pageInfos.get(item);messages.push([`${symbol} ${item}`,...(pageInfo?[pageInfo.isAmp?_chalk.default.cyan('AMP'):pageInfo.size>=0?getPrettySize(pageInfo.size):'N/A',pageInfo.chunks?pageInfo.chunks.internal.size.toString():'N/A',pageInfo.chunks?pageInfo.chunks.external.size.toString():'N/A']:['','',''])]);});console.log((0,_textTable.default)(messages,{align:['l','l','r','r'],stringLength:str=>(0,_stripAnsi.default)(str).length}));console.log();}function flatten(arr){return arr.reduce((acc,val)=>acc.concat(val),[]);}function getPossibleFiles(pageExtensions,pages){const res=pages.map(page=>pageExtensions.map(e=>`${page}.${e}`).concat(pageExtensions.map(e=>`${_path.default.join(page,'index')}.${e}`)).concat(page));return flatten(res);}async function getFileForPage({page,pagesDirectory,pageExtensions}){const theFile=getPossibleFiles(pageExtensions,[_path.default.join(pagesDirectory,page)]).find(f=>_fs.default.existsSync(f)&&_fs.default.lstatSync(f).isFile());if(theFile){return _path.default.sep+_path.default.relative(pagesDirectory,theFile);}return theFile;}async function getSpecifiedPages(dir,pagesString,pageExtensions){const pagesDir=_path.default.join(dir,'pages');const reservedPages=['/_app','/_document','/_error'];const explodedPages=[...new Set([...pagesString.split(','),...reservedPages])].map(p=>{let resolvedPage;if(_path.default.isAbsolute(p)){resolvedPage=getPossibleFiles(pageExtensions,[_path.default.join(pagesDir,p),p]).find(f=>_fs.default.existsSync(f)&&_fs.default.lstatSync(f).isFile());}else{resolvedPage=getPossibleFiles(pageExtensions,[_path.default.join(pagesDir,p),_path.default.join(dir,p)]).find(f=>_fs.default.existsSync(f)&&_fs.default.lstatSync(f).isFile());}return{original:p,resolved:resolvedPage||null};});const missingPage=explodedPages.find(({original,resolved})=>!resolved&&!reservedPages.includes(original));if(missingPage){throw new Error(`Unable to identify page: ${missingPage.original}`);}const resolvedPagePaths=explodedPages.filter(page=>page.resolved).map(page=>'/'+_path.default.relative(pagesDir,page.resolved));return resolvedPagePaths.sort();}async function getCacheIdentifier({pagesDirectory,env={}}){let selectivePageBuildingCacheIdentifier='';const envObject=env?Object.keys(env).sort()// eslint-disable-next-line
.reduce((a,c)=>(a[c]=env[c],a),{}):{};selectivePageBuildingCacheIdentifier+=JSON.stringify(envObject);const pkgPath=await(0,_findUp.default)('package.json',{cwd:pagesDirectory});if(pkgPath){const yarnLock=_path.default.join(_path.default.dirname(pkgPath),'yarn.lock');const packageLock=_path.default.join(_path.default.dirname(pkgPath),'package-lock.json');if(await fsExists(yarnLock)){selectivePageBuildingCacheIdentifier+=await fsReadFile(yarnLock,'utf8');}else if(await fsExists(packageLock)){selectivePageBuildingCacheIdentifier+=await fsReadFile(packageLock,'utf8');}else{selectivePageBuildingCacheIdentifier+=JSON.stringify(require(pkgPath));}}return _crypto.default.createHash('sha1').update(selectivePageBuildingCacheIdentifier).digest('hex');}async function getPageSizeInKb(page,distPath,buildId){const clientBundle=_path.default.join(distPath,`static/${buildId}/pages/`,`${page}.js`);try{return(await fsStat(clientBundle)).size;}catch(_){}return-1;}