"use strict";exports.__esModule=true;exports.default=getBaseWebpackConfig;var _forkTsCheckerWebpackPlugin=_interopRequireDefault(require("fork-ts-checker-webpack-plugin"));var _fs=_interopRequireDefault(require("fs"));var _constants=require("next-server/constants");var _index=_interopRequireDefault(require("next/dist/compiled/resolve/index.js"));var _path=_interopRequireDefault(require("path"));var _util=require("util");var _webpack=_interopRequireDefault(require("webpack"));var _constants2=require("../lib/constants");var _allModulesIdentifiedPlugin=require("./webpack/plugins/all-modules-identified-plugin");var _buildManifestPlugin=_interopRequireDefault(require("./webpack/plugins/build-manifest-plugin"));var _chunkGraphPlugin=require("./webpack/plugins/chunk-graph-plugin");var _chunkNamesPlugin=_interopRequireDefault(require("./webpack/plugins/chunk-names-plugin"));var _dllImport=require("./webpack/plugins/dll-import");var _hashedChunkIdsPlugin=require("./webpack/plugins/hashed-chunk-ids-plugin");var _nextDropClientPagePlugin=require("./webpack/plugins/next-drop-client-page-plugin");var _nextjsSsrImport=_interopRequireDefault(require("./webpack/plugins/nextjs-ssr-import"));var _nextjsSsrModuleCache=_interopRequireDefault(require("./webpack/plugins/nextjs-ssr-module-cache"));var _pagesManifestPlugin=_interopRequireDefault(require("./webpack/plugins/pages-manifest-plugin"));var _reactLoadablePlugin=require("./webpack/plugins/react-loadable-plugin");var _serverlessPlugin=require("./webpack/plugins/serverless-plugin");var _sharedRuntimePlugin=require("./webpack/plugins/shared-runtime-plugin");var _index2=require("./webpack/plugins/terser-webpack-plugin/src/index");function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}const fileExists=(0,_util.promisify)(_fs.default.exists);async function getBaseWebpackConfig(dir,{dev=false,debug=false,isServer=false,buildId,config,target='server',entrypoints,selectivePageBuilding=false}){const distDir=_path.default.join(dir,config.distDir);const defaultLoaders={babel:{loader:'next-babel-loader',options:{isServer,distDir,cwd:dir,asyncToPromises:config.experimental.asyncToPromises}},// Backwards compat
hotSelfAccept:{loader:'noop-loader'}// Support for NODE_PATH
};const nodePathList=(process.env.NODE_PATH||'').split(process.platform==='win32'?';':':').filter(p=>!!p);const outputDir=target==='serverless'?'serverless':_constants.SERVER_DIRECTORY;const outputPath=_path.default.join(distDir,isServer?outputDir:'');const totalPages=Object.keys(entrypoints).length;const clientEntries=!isServer?{// Backwards compatibility
'main.js':[],[_constants.CLIENT_STATIC_FILES_RUNTIME_MAIN]:`.${_path.default.sep}`+_path.default.relative(dir,_path.default.join(_constants2.NEXT_PROJECT_ROOT_DIST_CLIENT,dev?`next-dev.js`:'next.js'))}:undefined;let typeScriptPath;try{typeScriptPath=_index.default.sync('typescript',{basedir:dir});}catch(_){}const tsConfigPath=_path.default.join(dir,'tsconfig.json');const useTypeScript=Boolean(typeScriptPath&&(await fileExists(tsConfigPath)));const resolveConfig={// Disable .mjs for node_modules bundling
extensions:isServer?[...(useTypeScript?['.tsx','.ts']:[]),'.js','.mjs','.jsx','.json','.wasm']:[...(useTypeScript?['.tsx','.ts']:[]),'.mjs','.js','.jsx','.json','.wasm'],modules:['node_modules',...nodePathList],alias:{// These aliases make sure the wrapper module is not included in the bundles
// Which makes bundles slightly smaller, but also skips parsing a module that we know will result in this alias
'next/head':'next-server/dist/lib/head.js','next/router':'next/dist/client/router.js','next/config':'next-server/dist/lib/runtime-config.js','next/dynamic':'next-server/dist/lib/dynamic.js',next:_constants2.NEXT_PROJECT_ROOT,[_constants2.PAGES_DIR_ALIAS]:_path.default.join(dir,'pages'),[_constants2.DOT_NEXT_ALIAS]:distDir},mainFields:isServer?['main','module']:['browser','module','main']};const webpackMode=dev?'development':'production';const terserPluginConfig={parallel:true,sourceMap:false,cache:!selectivePageBuilding,cpus:config.experimental.cpus,distDir:distDir};const devtool=dev||debug?'cheap-module-source-map':false;let webpackConfig={devtool,mode:webpackMode,name:isServer?'server':'client',target:isServer?'node':'web',externals:!isServer?undefined:target!=='serverless'?[(context,request,callback)=>{const notExternalModules=['next/app','next/document','next/link','next/error','string-hash','next/constants'];if(notExternalModules.indexOf(request)!==-1){return callback();}(0,_index.default)(request,{basedir:dir,preserveSymlinks:true},(err,res)=>{if(err){return callback();}if(!res){return callback();}// Default pages have to be transpiled
if(res.match(/next[/\\]dist[/\\]/)||res.match(/node_modules[/\\]@babel[/\\]runtime[/\\]/)||res.match(/node_modules[/\\]@babel[/\\]runtime-corejs2[/\\]/)){return callback();}// Webpack itself has to be compiled because it doesn't always use module relative paths
if(res.match(/node_modules[/\\]webpack/)||res.match(/node_modules[/\\]css-loader/)){return callback();}// styled-jsx has to be transpiled
if(res.match(/node_modules[/\\]styled-jsx/)){return callback();}if(res.match(/node_modules[/\\].*\.js$/)){return callback(undefined,`commonjs ${request}`);}callback();});}]:[// When the serverless target is used all node_modules will be compiled into the output bundles
'amp-toolbox-optimizer'],optimization:Object.assign({checkWasmTypes:false,nodeEnv:false},isServer?{splitChunks:false,minimize:false}:{runtimeChunk:selectivePageBuilding?false:{name:_constants.CLIENT_STATIC_FILES_RUNTIME_WEBPACK},splitChunks:dev?{cacheGroups:{default:false,vendors:false}}:selectivePageBuilding?{cacheGroups:{default:false,vendors:false,react:{name:'commons',chunks:'all',test:/[\\/]node_modules[\\/](react|react-dom)[\\/]/}}}:{chunks:'all',cacheGroups:{default:false,vendors:false,commons:{name:'commons',chunks:'all',minChunks:totalPages>2?totalPages*0.5:2},react:{name:'commons',chunks:'all',test:/[\\/]node_modules[\\/](react|react-dom)[\\/]/}}},minimize:!(dev||debug),minimizer:!(dev||debug)?[new _index2.TerserPlugin({...terserPluginConfig,terserOptions:{safari10:true,...(selectivePageBuilding||config.experimental.terserLoader?{compress:false,mangle:true}:undefined)}})]:undefined},selectivePageBuilding?{providedExports:false,usedExports:false,concatenateModules:false}:undefined),recordsPath:selectivePageBuilding?undefined:_path.default.join(outputPath,'records.json'),context:dir,// Kept as function to be backwards compatible
entry:async()=>{return{...(clientEntries?clientEntries:{}),...entrypoints};},output:{path:outputPath,filename:({chunk})=>{// Use `[name]-[contenthash].js` in production
if(!dev&&(chunk.name===_constants.CLIENT_STATIC_FILES_RUNTIME_MAIN||chunk.name===_constants.CLIENT_STATIC_FILES_RUNTIME_WEBPACK)){return chunk.name.replace(/\.js$/,'-[contenthash].js');}return'[name]';},libraryTarget:isServer?'commonjs2':'var',hotUpdateChunkFilename:'static/webpack/[id].[hash].hot-update.js',hotUpdateMainFilename:'static/webpack/[hash].hot-update.json',// This saves chunks with the name given via `import()`
chunkFilename:isServer?`${dev?'[name]':'[name].[contenthash]'}.js`:`static/chunks/${dev?'[name]':'[name].[contenthash]'}.js`,strictModuleExceptionHandling:true,crossOriginLoading:config.crossOrigin,futureEmitAssets:!dev,webassemblyModuleFilename:'static/wasm/[modulehash].wasm'},performance:false,resolve:resolveConfig,resolveLoader:{modules:[_path.default.join(__dirname,'webpack','loaders'),// The loaders Next.js provides
'node_modules',...nodePathList]},// @ts-ignore this is filtered
module:{rules:[(selectivePageBuilding||config.experimental.terserLoader)&&!isServer&&!debug&&{test:/\.(js|mjs|jsx)$/,exclude:/\.min\.(js|mjs|jsx)$/,use:{loader:'next-minify-loader',options:{terserOptions:{safari10:true,compress:true,mangle:false}}}},config.experimental.ampBindInitData&&!isServer&&{test:/\.(tsx|ts|js|mjs|jsx)$/,include:[_path.default.join(dir,'data')],use:'next-data-loader'},{test:/\.(tsx|ts|js|mjs|jsx)$/,include:[dir,/next-server[\\/]dist[\\/]lib/,/next[\\/]dist[\\/]client/,/next[\\/]dist[\\/]pages/],exclude:path=>{if(/next-server[\\/]dist[\\/]lib/.test(path)||/next[\\/]dist[\\/]client/.test(path)||/next[\\/]dist[\\/]pages/.test(path)){return false;}return /node_modules/.test(path);},use:defaultLoaders.babel}].filter(Boolean)},plugins:[// This plugin makes sure `output.filename` is used for entry chunks
new _chunkNamesPlugin.default(),new _webpack.default.DefinePlugin({...Object.keys(config.env).reduce((acc,key)=>{if(/^(?:NODE_.+)|(?:__.+)$/i.test(key)){throw new Error(`The key "${key}" under "env" in next.config.js is not allowed. https://err.sh/zeit/next.js/env-key-not-allowed`);}return{...acc,[`process.env.${key}`]:JSON.stringify(config.env[key])};},{}),'process.env.NODE_ENV':JSON.stringify(webpackMode),'process.crossOrigin':JSON.stringify(config.crossOrigin),'process.browser':JSON.stringify(!isServer),// This is used in client/dev-error-overlay/hot-dev-client.js to replace the dist directory
...(dev&&!isServer?{'process.env.__NEXT_DIST_DIR':JSON.stringify(distDir)}:{}),'process.env.__NEXT_EXPERIMENTAL_DEBUG':JSON.stringify(debug),'process.env.__NEXT_EXPORT_TRAILING_SLASH':JSON.stringify(config.experimental.exportTrailingSlash)}),!isServer&&new _reactLoadablePlugin.ReactLoadablePlugin({filename:_constants.REACT_LOADABLE_MANIFEST}),!isServer&&new _nextDropClientPagePlugin.DropClientPage(),new _chunkGraphPlugin.ChunkGraphPlugin(buildId,{dir,distDir,isServer}),...(dev?(()=>{// Even though require.cache is server only we have to clear assets from both compilations
// This is because the client compilation generates the build manifest that's used on the server side
const{NextJsRequireCacheHotReloader}=require('./webpack/plugins/nextjs-require-cache-hot-reloader');const{UnlinkRemovedPagesPlugin}=require('./webpack/plugins/unlink-removed-pages-plugin');const devPlugins=[new UnlinkRemovedPagesPlugin(),new _webpack.default.NoEmitOnErrorsPlugin(),new NextJsRequireCacheHotReloader()];if(!isServer){const AutoDllPlugin=(0,_dllImport.importAutoDllPlugin)({distDir});devPlugins.push(new AutoDllPlugin({filename:'[name]_[hash].js',path:'./static/development/dll',context:dir,entry:{dll:['react','react-dom']},config:{devtool,mode:webpackMode,resolve:resolveConfig}}));devPlugins.push(new _webpack.default.HotModuleReplacementPlugin());}return devPlugins;})():[]),!dev&&new _webpack.default.HashedModuleIdsPlugin(),// This must come after HashedModuleIdsPlugin (it sets any modules that
!dev&&selectivePageBuilding&&new _allModulesIdentifiedPlugin.AllModulesIdentifiedPlugin(dir),// This sets chunk ids to be hashed versions of their names to reduce
!dev&&selectivePageBuilding&&new _hashedChunkIdsPlugin.HashedChunkIdsPlugin(buildId),// On the client we want to share the same runtime cache
!isServer&&selectivePageBuilding&&new _sharedRuntimePlugin.SharedRuntimePlugin(),!dev&&new _webpack.default.IgnorePlugin({checkResource:resource=>{return /react-is/.test(resource);},checkContext:context=>{return /next-server[\\/]dist[\\/]/.test(context)||/next[\\/]dist[\\/]/.test(context);}}),target==='serverless'&&(isServer||selectivePageBuilding)&&new _serverlessPlugin.ServerlessPlugin(buildId,{isServer}),target!=='serverless'&&isServer&&new _pagesManifestPlugin.default(),target!=='serverless'&&isServer&&new _nextjsSsrModuleCache.default({outputPath}),isServer&&new _nextjsSsrImport.default(),!isServer&&new _buildManifestPlugin.default(),config.experimental.profiling&&new _webpack.default.debug.ProfilingPlugin({outputPath:_path.default.join(distDir,`profile-events-${isServer?'server':'client'}.json`)}),!isServer&&useTypeScript&&new _forkTsCheckerWebpackPlugin.default({typescript:typeScriptPath,async:false,useTypescriptIncrementalApi:true,checkSyntacticErrors:true,tsconfig:tsConfigPath,reportFiles:['**','!**/__tests__/**','!**/?(*.)(spec|test).*'],compilerOptions:{isolatedModules:true,noEmit:true},silent:true,formatter:'codeframe'})].filter(Boolean)};if(typeof config.webpack==='function'){webpackConfig=config.webpack(webpackConfig,{dir,dev,isServer,buildId,config,defaultLoaders,totalPages,webpack:_webpack.default});// @ts-ignore: Property 'then' does not exist on type 'Configuration'
if(typeof webpackConfig.then==='function'){console.warn('> Promise returned in next config. https://err.sh/zeit/next.js/promise-in-next-config.md');}}// check if using @zeit/next-typescript and show warning
if(isServer&&webpackConfig.module&&Array.isArray(webpackConfig.module.rules)){let foundTsRule=false;webpackConfig.module.rules=webpackConfig.module.rules.filter(rule=>{if(!(rule.test instanceof RegExp))return true;if('noop.ts'.match(rule.test)&&!'noop.js'.match(rule.test)){// remove if it matches @zeit/next-typescript
foundTsRule=rule.use===defaultLoaders.babel;return!foundTsRule;}return true;});if(foundTsRule){console.warn('\n@zeit/next-typescript is no longer needed since Next.js has built-in support for TypeScript now. Please remove it from your next.config.js\n');}}// Backwards compat for `main.js` entry key
const originalEntry=webpackConfig.entry;if(typeof originalEntry!=='undefined'){webpackConfig.entry=async()=>{const entry=typeof originalEntry==='function'?await originalEntry():originalEntry;// Server compilation doesn't have main.js
if(clientEntries&&entry['main.js']&&entry['main.js'].length>0){const originalFile=clientEntries[_constants.CLIENT_STATIC_FILES_RUNTIME_MAIN];entry[_constants.CLIENT_STATIC_FILES_RUNTIME_MAIN]=[...entry['main.js'],originalFile];}delete entry['main.js'];return entry;};}if(!dev){// @ts-ignore entry is always a function
webpackConfig.entry=await webpackConfig.entry();}return webpackConfig;}