"use strict";var _interopRequireWildcard=require("@babel/runtime-corejs2/helpers/interopRequireWildcard");var _interopRequireDefault=require("@babel/runtime-corejs2/helpers/interopRequireDefault");exports.__esModule=true;exports.default=void 0;var _map=_interopRequireDefault(require("@babel/runtime-corejs2/core-js/map"));var _url=require("url");var _react=_interopRequireWildcard(require("react"));var _propTypes=_interopRequireDefault(require("prop-types"));var _router=_interopRequireDefault(require("./router"));var _rewriteUrlForExport=require("next-server/dist/lib/router/rewrite-url-for-export");var _utils=require("next-server/dist/lib/utils");/* global __NEXT_DATA__ */function isLocal(href){const url=(0,_url.parse)(href,false,true);const origin=(0,_url.parse)((0,_utils.getLocationOrigin)(),false,true);return!url.host||url.protocol===origin.protocol&&url.host===origin.host;}function memoizedFormatUrl(formatFunc){let lastHref=null;let lastAs=null;let lastResult=null;return(href,as)=>{if(lastResult&&href===lastHref&&as===lastAs){return lastResult;}const result=formatFunc(href,as);lastHref=href;lastAs=as;lastResult=result;return result;};}function formatUrl(url){return url&&typeof url==='object'?(0,_utils.formatWithValidation)(url):url;}let observer;const listeners=new _map.default();const IntersectionObserver=typeof window!=='undefined'?window.IntersectionObserver:null;function getObserver(){// Return shared instance of IntersectionObserver if already created
if(observer){return observer;}// Only create shared IntersectionObserver if supported in browser
if(!IntersectionObserver){return undefined;}return observer=new IntersectionObserver(entries=>{entries.forEach(entry=>{if(!listeners.has(entry.target)){return;}const cb=listeners.get(entry.target);if(entry.isIntersecting||entry.intersectionRatio>0){observer.unobserve(entry.target);listeners.delete(entry.target);cb();}});},{rootMargin:'200px'});}const listenToIntersections=(el,cb)=>{const observer=getObserver();if(!observer){return()=>{};}observer.observe(el);listeners.set(el,cb);return()=>{observer.unobserve(el);listeners.delete(el);};};class Link extends _react.Component{constructor(...args){super(...args);this.cleanUpListeners=()=>{};this.formatUrls=memoizedFormatUrl((href,asHref)=>{return{href:formatUrl(href),as:asHref?formatUrl(asHref):asHref};});this.linkClicked=e=>{// @ts-ignore target exists on currentTarget
const _e$currentTarget=e.currentTarget,nodeName=_e$currentTarget.nodeName,target=_e$currentTarget.target;if(nodeName==='A'&&(target&&target!=='_self'||e.metaKey||e.ctrlKey||e.shiftKey||e.nativeEvent&&e.nativeEvent.which===2)){// ignore click for new tab / new window behavior
return;}let _this$formatUrls=this.formatUrls(this.props.href,this.props.as),href=_this$formatUrls.href,as=_this$formatUrls.as;if(!isLocal(href)){// ignore click if it's outside our scope
return;}const pathname=window.location.pathname;href=(0,_url.resolve)(pathname,href);as=as?(0,_url.resolve)(pathname,as):href;e.preventDefault();//  avoid scroll for urls with anchor refs
let scroll=this.props.scroll;if(scroll==null){scroll=as.indexOf('#')<0;}// replace state instead of push if prop is present
_router.default[this.props.replace?'replace':'push'](href,as,{shallow:this.props.shallow}).then(success=>{if(!success)return;if(scroll){window.scrollTo(0,0);document.body.focus();}}).catch(err=>{if(this.props.onError)this.props.onError(err);});};}componentDidMount(){this.cleanUpListeners=()=>{};}componentWillUnmount(){this.cleanUpListeners();}handleRef(ref){if(IntersectionObserver&&ref&&ref.tagName){this.cleanUpListeners=listenToIntersections(ref,()=>{this.prefetch();});}}// The function is memoized so that no extra lifecycles are needed
// as per https://reactjs.org/blog/2018/06/07/you-probably-dont-need-derived-state.html
prefetch(){if(typeof window==='undefined')return;// Prefetch the JSON page if asked (only in the client)
const pathname=window.location.pathname;const _this$formatUrls2=this.formatUrls(this.props.href,this.props.as),parsedHref=_this$formatUrls2.href;const href=(0,_url.resolve)(pathname,parsedHref);_router.default.prefetch(href);}render(){let children=this.props.children;const _this$formatUrls3=this.formatUrls(this.props.href,this.props.as),href=_this$formatUrls3.href,as=_this$formatUrls3.as;// Deprecated. Warning shown by propType check. If the childen provided is a string (<Link>example</Link>) we wrap it in an <a> tag
if(typeof children==='string'){children=_react.default.createElement("a",null,children);}// This will return the first child, if multiple are provided it will throw an error
const child=_react.Children.only(children);const props={ref:el=>this.handleRef(el),onMouseEnter:()=>{this.prefetch();},onClick:e=>{if(child.props&&typeof child.props.onClick==='function'){child.props.onClick(e);}if(!e.defaultPrevented){this.linkClicked(e);}}// If child is an <a> tag and doesn't have a href attribute, or if the 'passHref' property is
// defined, we specify the current 'href', so that repetition is not needed by the user
};if(this.props.passHref||child.type==='a'&&!('href'in child.props)){props.href=as||href;}// Add the ending slash to the paths. So, we can serve the
// "<page>/index.html" directly.
if(process.env.__NEXT_EXPORT_TRAILING_SLASH){if(props.href&&typeof __NEXT_DATA__!=='undefined'&&__NEXT_DATA__.nextExport){props.href=(0,_rewriteUrlForExport.rewriteUrlForNextExport)(props.href);}}return _react.default.cloneElement(child,props);}}Link.propTypes=void 0;if(process.env.NODE_ENV==='development'){const warn=(0,_utils.execOnce)(console.error);// This module gets removed by webpack.IgnorePlugin
const exact=require('prop-types-exact');Link.propTypes=exact({href:_propTypes.default.oneOfType([_propTypes.default.string,_propTypes.default.object]).isRequired,as:_propTypes.default.oneOfType([_propTypes.default.string,_propTypes.default.object]),prefetch:_propTypes.default.bool,replace:_propTypes.default.bool,shallow:_propTypes.default.bool,passHref:_propTypes.default.bool,scroll:_propTypes.default.bool,children:_propTypes.default.oneOfType([_propTypes.default.element,(props,propName)=>{const value=props[propName];if(typeof value==='string'){warn(`Warning: You're using a string directly inside <Link>. This usage has been deprecated. Please add an <a> tag as child of <Link>`);}return null;}]).isRequired});}var _default=Link;exports.default=_default;